/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AverageTrueRangeIndicatorStrategy } from "./AverageTrueRangeIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class AverageTrueRangeIndicator extends StrategyBasedIndicator {
    get_qc() {
        return new AverageTrueRangeIndicatorStrategy();
    }
    get qc() {
        return this.get_qc();
    }
    get_qp() {
        return AverageTrueRangeIndicator.$;
    }
    get qp() {
        return this.get_qp();
    }
    get qx() {
        return typeGetValue(this.c(AverageTrueRangeIndicator.qy));
    }
    set qx(a) {
        this.h(AverageTrueRangeIndicator.qy, a);
    }
    qi() {
        return this.qx;
    }
    qr(a) {
        this.qx = a;
    }
}
AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
AverageTrueRangeIndicator.qy = StrategyBasedIndicator.qu(14, AverageTrueRangeIndicator.$);
//# sourceMappingURL=AverageTrueRangeIndicator.js.map