/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_qc() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get qc() {
        return this.get_qc();
    }
    get_qp() {
        return FullStochasticOscillatorIndicator.$;
    }
    get qp() {
        return this.get_qp();
    }
    get qx() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.q2));
    }
    set qx(a) {
        this.h(FullStochasticOscillatorIndicator.q2, a);
    }
    qi() {
        return this.qx;
    }
    qr(a) {
        this.qx = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.q3));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.q3, a);
    }
    qk() {
        return this.smoothingPeriod;
    }
    get qz() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.q4));
    }
    set qz(a) {
        this.h(FullStochasticOscillatorIndicator.q4, a);
    }
    qh() {
        return this.qz;
    }
    ps() {
        return this.qz;
    }
}
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FullStochasticOscillatorIndicator.q2 = StrategyBasedIndicator.qu(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.q3 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.q4 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map