/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export class RadialBucketCalculator extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.b = 0;
        this.a = a;
    }
    getBucket(a) {
        throw new NotImplementedException(0);
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    getBucketInfo(a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cn.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    e(a) {
        let b = this.a.bs;
        let c = this.a.br;
        let d = this.a.cn.m0;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cn.bz == null || this.a.cn.bz.count == 0) {
            this.b = 0;
            return;
        }
        let e = Math.floor(d.ld(c, b));
        let f = Math.ceil(d.lc(c, b));
        if (d.b8) {
            f = Math.ceil(d.ld(c, b));
            e = Math.floor(d.lc(c, b));
        }
        if (f < e) {
            f = d.jy + f;
        }
        let g = this.a.cn.m2;
        let h = g != null ? g.lj : 0.75;
        let i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        let j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
/**
 * @hidden
 */
export class RadialBase extends MarkerSeries {
    constructor() {
        super();
        this.m8 = null;
        this.m6 = new RadialFrame(3);
        this.m7 = new RadialFrame(3);
        this.m5 = new RadialFrame(3);
        this.m3 = null;
        this.m8 = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(this, this.nk), runOn(this, this.nl), runOn(this, this.ca), runOn(this, this.jl), runOn(this, this.nj), (a) => this.m4.co.e(this.eu));
    }
    iu(a) {
        super.iu(a);
        this.m4 = a;
    }
    nj() {
        if (this.bt.g) {
            this.bt.t();
        }
    }
    get categoryAxis() {
        return this.m0;
    }
    ap() {
        return this.m0;
    }
    nc(a) {
        if (!this.hasMarkers) {
            return false;
        }
        let b = this.m0;
        let c = new ScalerParams(1, this.bs.mq, this.ly, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        let d = this.m2;
        let e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l0.cc((f) => {
            if (f._visibility == 0) {
                let g = new SeriesPointOfInterest();
                let h = f.n;
                let i = f.o;
                if (h < this.ly.left || h > this.ly.right || i < this.ly.top || i > this.ly.bottom) {
                    return;
                }
                g.b = b.dz(h, c);
                g.c = d.dz(i, e);
                g.d = b.fj(f.ak);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    }
    get_c2() {
        return true;
    }
    ag() {
        return [this.m0, this.m2];
    }
    jt(a, b) {
        this.m4.co.e(this.eu);
        this.jd(false);
    }
    js(a, b) {
        this.m4.co.e(this.eu);
        this.jd(false);
    }
    iz(a, b, c, d) {
        super.iz(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.m0 != null) {
                        this.m0.bv(this);
                    }
                    if (this.m2 != null) {
                        this.m2.bv(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.m0 != null) {
                        this.m0.ci(this);
                    }
                    if (this.m2 != null) {
                        this.m2.ci(this);
                    }
                }
                this.m4.co.e(this.eu);
                this.jd(false);
                break;
            case RadialBase.$$p[0]:
                if (this.m0 != null && this.m2 != null) {
                    this.m3 = new RadialAxes(this.m2, this.m0);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.m4.co.e(this.eu);
                this.jd(false);
                break;
            case RadialBase.$$p[2]:
                if (this.m0 != null && this.m2 != null) {
                    this.m3 = new RadialAxes(this.m2, this.m0);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.m4.co.e(this.eu);
                if (this.m2 == null || !this.m2.cl()) {
                    this.jd(false);
                }
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.m4.co.e(this.eu);
                    this.jd(false);
                }
                break;
            case "TransitionProgress":
                this.m7.c(this.ez, this.m6, this.m5);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.nl(this.m5, this.m4);
                }
                else {
                    this.nl(this.m7, this.m4);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.jd(false);
                this.ik();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.m4.co.e(this.eu);
                }
                break;
        }
    }
    na(a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    m9(a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    fp(a) {
        let b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    nd(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        if (this.m0 != null && !b.isEmpty && !c.isEmpty && this.m3 != null) {
            let d = this.m3.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    }
    ne(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = -1;
        if (this.m0 != null && !b.isEmpty && !c.isEmpty && this.m3 != null) {
            let e = this.m3.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            let f = this.m0.getUnscaledAngle(e);
            if (this.m0.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    }
    e8(a) {
        let b = truncate(Math.round(this.ne(a)));
        if (this.bz != null && b == this.bz.count) {
            b = 0;
        }
        return b;
    }
    c9(a) {
        return false;
    }
    ib() {
        super.ib();
        if (this.m0 != null) {
            this.m0.g6(false);
        }
        if (this.m2 != null) {
            this.m2.g6(false);
        }
    }
    dw(a, b, c) {
        let d = true;
        let e = c;
        if (!super.dw(a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.m0 == null || this.m0.itemsSource == null || this.m2 == null || this.m3 == null || this.bz == null || this.m0.bf == null || this.m2.bf == null || this.m2.j4 == this.m2.j3) {
            e.co.b = 0;
            d = false;
        }
        return d;
    }
    je(a) {
        let b;
        let c;
        let d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.hv(true, this.bi);
            return;
        }
        let e = new SeriesRenderingArguments(this, c, b, a, this.de);
        let f = this.m8.g(e, this.m6, this.m5, this.m7, this.m4);
        this.m6 = f.p1;
        this.m5 = f.p2;
        this.m7 = f.p3;
    }
    nf() {
        let a = 0;
        for (let b of fromEnum(this.bs.series)) {
            if (b == this) {
                return a;
            }
            let c = typeCast(RadialBase.$, b);
            if (c != null && c.m0 == this.m0 && c.preferredCategoryMode(c.m0) == 2) {
                a++;
            }
        }
        return -1;
    }
}
RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:m0:nm', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:nb:nn', [0, false], 'ValueAxis:m2:no', [NumericRadiusAxis.$, null]]);
/**
 * @hidden
 */
export class RadialBaseView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.co = null;
        this.cn = null;
        this.cp = null;
        this.cq = 0;
        this.cr = null;
        this.cn = a;
        this.cp = new Pool$1(Marker.$);
        this.cf(this.cp);
    }
    cc(a) {
        this.cp.c(a);
    }
}
RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
//# sourceMappingURL=RadialBucketCalculator_combined.js.map