/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RingSeriesBase } from "./RingSeriesBase";
import { Ring } from "./Ring";
import { ArcItem } from "./ArcItem";
import { fromEnum, markType } from "igniteui-angular-core";
import { RingCollection } from "./RingCollection";
/**
 * @hidden
 */
export class RingSeries extends RingSeriesBase {
    constructor() {
        super();
        this.dx = null;
        this.dx = ((() => {
            let $ret = new Ring();
            $ret.c = this;
            $ret.e = false;
            return $ret;
        })());
        let a = ((() => {
            let $ret = new ArcItem();
            $ret.k = this.a4;
            $ret.d = this.dx;
            $ret.n = this.b9;
            $ret.c = this.al;
            $ret.j = this.a2;
            return $ret;
        })());
        this.dx.g.add(a);
        this.ab = RingSeries.$;
    }
    cl(a, b, c, d) {
        super.cl(a, b, c, d);
        if (b == RingSeriesBase.$$p[2]) {
            for (let e = 0; e < this.dx.ringControl.arcs.count; e++) {
                this.dx.ringControl.arcs.item(e).at = d;
            }
        }
        if (b == RingSeriesBase.$$p[3]) {
            for (let f = 0; f < this.dx.ringControl.arcs.count; f++) {
                this.dx.ringControl.arcs.item(f).au = d;
            }
        }
        if (b == RingSeriesBase.$$p[16]) {
            for (let g = 0; g < this.dx.ringControl.arcs.count; g++) {
                this.dx.ringControl.arcs.item(g).dv = this.br;
            }
        }
        if (b == RingSeriesBase.$$p[0]) {
            this.cj();
        }
        if (b == RingSeriesBase.$$p[25]) {
            if (this.dx.g != null && this.dx.g.count > 0) {
                this.dx.g._inner[0].k = this.a4;
            }
        }
        if (b == RingSeriesBase.$$p[28]) {
            if (this.dx.g != null && this.dx.g.count > 0) {
                this.dx.g._inner[0].n = this.b9;
                this.ck();
            }
        }
        if (this.dx != null && this.as.e()) {
            this.dx.o();
            if (this.dx.f()) {
                this.dx.c.as.l();
            }
        }
    }
    aq() {
        let a = new RingCollection();
        if (this.dx.g._inner[0].g.count > 0) {
            a.add(this.dx);
        }
        return a;
    }
    ck() {
        if (this.dx != null) {
            this.dx.g._inner[0].h = this.itemsSource;
            this.dx.g._inner[0].p(this.a4);
            if (this.at != null) {
                this.at.bx();
                this.at.b2();
            }
        }
    }
    cj() {
        if (this.dx != null) {
            this.dx.g._inner[0].a = this.ag;
        }
    }
    cp() {
        if (this.dx != null) {
            this.width = this.dx.q.width;
            this.height = this.dx.q.height;
            this.as.m(this.dx.p.x, this.dx.p.y);
        }
    }
    co() {
        if (this.dx != null) {
            for (let a of fromEnum(this.dx.ringControl.arcs.a)) {
                a.fg();
            }
        }
    }
    cf(a, b) {
        super.cf(a, b);
        if (this.dx != null) {
            this.dx.l(this.itemsSource, a, b);
        }
    }
    ce() {
        super.ce();
        if (this.dx != null) {
            this.dx.k(this.itemsSource);
        }
    }
    cg(a, b) {
        super.cg(a, b);
        if (this.dx != null) {
            this.dx.m(this.itemsSource, a, b);
        }
    }
    ch(a, b, c) {
        super.ch(a, b, c);
        if (this.dx != null) {
            this.dx.n(this.itemsSource, a, b, c);
        }
    }
}
RingSeries.$t = markType(RingSeries, 'RingSeries', RingSeriesBase.$);
//# sourceMappingURL=RingSeries.js.map