/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.qf = null;
        _this.sx = null;
        _this.sv = null;
        _this.ss = null;
        _this.su = null;
        _this.sw = null;
        _this.st = null;
        _this.pl = null;
        _this.tf = null;
        _this.tg = null;
        _this.tc = null;
        _this.th = null;
        _this.ti = null;
        _this.td = null;
        _this.te = null;
        _this.q3 = null;
        _this.r8 = 40;
        _this.p9 = null;
        _this.p7 = null;
        _this.qb = null;
        _this.qg = null;
        _this.tq = null;
        _this.qz = null;
        _this.rn = false;
        _this.rm = false;
        _this.rs = false;
        _this.q9 = false;
        _this.s3 = 10;
        _this.sa = NaN;
        _this.sc = NaN;
        _this.sb = NaN;
        _this.sd = 0;
        _this.pr = 0;
        _this.pu = 0;
        _this.pw = 0;
        _this.q6 = true;
        _this.pn = 0;
        _this.q7 = false;
        _this.p1 = null;
        _this.p3 = null;
        _this.ru = null;
        _this.q8 = true;
        _this.q0 = null;
        _this.py = 1;
        _this.op = null;
        _this.oq = null;
        _this.or = null;
        _this.os = null;
        _this.ou = null;
        _this.ot = null;
        _this.oo = null;
        _this.on = null;
        _this.r9 = 1;
        _this.r7 = 1;
        _this.r6 = 1;
        _this.qd = null;
        _this.sz = -2147483648;
        _this.r5 = 2;
        _this.s2 = 3;
        _this.s0 = 10;
        _this.sy = 30;
        _this.s1 = 9;
        _this.pi = null;
        _this.pj = null;
        _this.pe = null;
        _this.applyCustomIndicators = null;
        _this.xa = null;
        _this.se = 1;
        _this.q5 = false;
        _this.p5 = null;
        _this.r2 = dateMinValue();
        _this.r1 = dateMaxValue();
        _this.rz = null;
        _this.f6();
        _this.rz = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.wz(); });
        }
        _this.wk();
        return _this;
    }
    FinancialChart.prototype.g5 = function (a, b, c) {
        _super.prototype.g5.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.pm = new FinancialChartToolbar(this, this.tn);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.v8));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.wb));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.wc));
                    d.l(null);
                }
                if (this.pm != null) {
                    this.pm.ac = this.pt;
                    this.pm.ai = this.av;
                    this.pm.y = this.po;
                    this.pm.al = this.rk;
                    if (this.su != null) {
                        this.pm.l(this.su);
                    }
                    var e = this.pm;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.v8));
                    ;
                    var f = this.pm;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.wb));
                    var g = this.pm;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.wc));
                }
                break;
            case "ChartType":
                if (this.pm != null) {
                    this.pm.y = this.po;
                }
                break;
            case "VolumeType":
                if (this.pm != null) {
                    this.pm.ac = this.pt;
                }
                break;
            case "TrendLineType":
                if (this.pm != null) {
                    this.pm.ai = this.av;
                }
                break;
            case "IsToolbarVisible":
                if (this.pm == null) {
                    break;
                }
                this.pm.al = this.rk;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.wc = function (a, b) {
        this.pt = this.pm.ac;
    };
    FinancialChart.prototype.wb = function (a, b) {
        this.av = this.pm.ai;
    };
    FinancialChart.prototype.v8 = function (a, b) {
        this.po = this.pm.y;
    };
    FinancialChart.prototype.wk = function () {
        this.qf = new IndicatorPane();
        this.p6 = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.sx = a;
        this.w5();
        this.setGridRows();
        if (this.pm != null) {
            this.pm.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.pm != null) {
            this.pm.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.pm.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.di;
        b.toolbarContainer = this.su;
        b.legendContainer = this.st;
        b.indicatorsContainer = this.ss;
        b.volumeContainer = this.sv;
        b.zoomContainer = this.sw;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.pm == null) {
                this.pm = new FinancialChartToolbar(this, this.tn);
            }
            this.pm.w.isIndicatorMenuVisible = this.rb && this.rc;
            this.su = b.getSubRenderer(d);
            this.pm.l(this.su);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.st = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ss = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.sv = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.sw = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.su = null;
            if (this.pm != null) {
                this.pm.l(null);
            }
            if (this.q4 != null) {
                this.q4.provideContainer(null);
                this.q4 = null;
            }
            if (this.p6 != null) {
                this.p6.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.sv);
            }
            if (this.qf != null) {
                this.qf.h(this.ss);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.sw);
                if (a != null) {
                    this.vs();
                }
                else {
                    this.q4 = null;
                }
            }
            if (this.p6 != null) {
                this.p6.provideContainer(this.st);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.wv = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.w9 = function (a, b) {
        this.wv(a, b, this.sw);
        if (b == null) {
            return;
        }
        this.vs();
    };
    FinancialChart.prototype.vs = function () {
        var _this = this;
        if (this.sw == null) {
            return;
        }
        if (this.q4 != null) {
            this.q4.provideContainer(null);
        }
        this.q4 = TypeRegistrar.create("ZoomSlider");
        this.q4.provideContainer(this.sw);
        var a = this.q4;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.m4 = new Rect(0, _this.q4.windowRect.left, _this.dataChart.mq.top, _this.q4.windowRect.width, _this.dataChart.mq.height);
            }
        });
        this.vt();
    };
    FinancialChart.prototype.w7 = function (a, b) {
        this.wv(a, b, this.sv);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.sx == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.rk ? this.sj : 0) + "px";
        a[1] = this.rg ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.q4 != null) {
            if (a[5] == "0px") {
                this.q4.hide();
            }
            else {
                this.q4.show();
            }
        }
        this.sx.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, tslib_1.__spread([" "], a)), "auto", "1fr"));
        this.sx.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, tslib_1.__spread([" "], a)));
        if (this.di == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.qf != null) {
            this.qf.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.q4 != null) {
            this.q4.notifySizeChanged();
        }
    };
    FinancialChart.prototype.gj = function () {
        _super.prototype.gj.call(this);
        this.ih = 3;
        this.nk = 0;
        this.cu = NaN;
        this.cs = 30;
        this.bq = true;
        this.bw = false;
        if (this.dataChart != null) {
            var a = this.dataChart.bn.i.e();
            this.ox = a.d;
            this.oy = a.e;
            this.ow = a.d;
            this.xb = this.dataChart.pm;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.oz = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.o0 = c;
    };
    FinancialChart.prototype.wr = function () {
        if (this.qf != null) {
            this.qf.b = null;
            this.qf.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ws = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.w1 = function () {
        this.wr();
    };
    FinancialChart.prototype.vr = function () {
        if (this.q4 == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.di.rootWrapper.width();
        var b = this.dataChart.m3.left + this.dataChart.m3.width;
        var c = this.dataChart.m3.left;
        var d = a - b;
        this.q4.startInset = c - this.q4.trackStartInset;
        this.q4.endInset = d - this.q4.trackEndInset;
        if (this.q4.endInset < 0) {
            var e = this.q4.endInset;
            this.q4.endInset = 0;
            this.dataChart.el += (e * -1);
        }
        if (this.q4.startInset < 0) {
            var f = this.q4.startInset;
            this.q4.startInset = 0;
            this.dataChart.ej += (f * -1);
        }
        this.zoomSliderChart.ej = c;
        this.zoomSliderChart.el = d;
        this.zoomSliderChart.ef = this.q4.barExtent;
    };
    FinancialChart.prototype.wi = function () {
        this.vr();
    };
    FinancialChart.prototype.gg = function (a) {
        _super.prototype.gg.call(this, a);
        if (a != null) {
            a.ee = 0;
        }
    };
    FinancialChart.prototype.xc = function (a) {
        return a.mj();
    };
    FinancialChart.prototype.xf = function () {
        return this.st == null ? null : this.xe(this.st.rootWrapper);
    };
    FinancialChart.prototype.xd = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.xe(a.d.rootWrapper);
    };
    FinancialChart.prototype.xe = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.sf = function () {
        if (this.sx == null) {
            return NaN;
        }
        var a = this.sx.getOffset();
        return this.sx.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.gr = function (source_, a, b) {
        _super.prototype.gr.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hy(source_, a, b);
        }
    };
    FinancialChart.prototype.gs = function (source_, a, b) {
        _super.prototype.gs.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hz(source_, a, b);
        }
    };
    FinancialChart.prototype.gq = function (source_) {
        _super.prototype.gq.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_);
        }
    };
    FinancialChart.prototype.gu = function (source_, a, b, c) {
        _super.prototype.gu.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.h0(source_, a, b, c);
        }
    };
    FinancialChart.prototype.gm = function (a, b) {
        _super.prototype.gm.call(this, a, b);
        if (this.rh(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "pm", {
        get: function () {
            return this.pl;
        },
        set: function (a) {
            var b = this.pm;
            if (a != b) {
                this.pl = a;
                this.g3("Toolbar", b, this.pm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tm", {
        get: function () {
            return this.tf;
        },
        set: function (a) {
            var b = this.tm;
            if (a != b) {
                this.tf = a;
                this.g3("RangeSelectorTemplate", b, this.tm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tn", {
        get: function () {
            return this.tg;
        },
        set: function (a) {
            var b = this.tn;
            if (a != b) {
                this.tg = a;
                this.g3("ToolbarTemplate", b, this.tn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tj", {
        get: function () {
            return this.tc;
        },
        set: function (a) {
            var b = this.tj;
            if (a != b) {
                this.tc = a;
                this.g3("ChartTypePickerTemplate", b, this.tj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "to", {
        get: function () {
            return this.th;
        },
        set: function (a) {
            var b = this.to;
            if (a != b) {
                this.th = a;
                this.g3("TrendLineTypePickerTemplate", b, this.to);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tp", {
        get: function () {
            return this.ti;
        },
        set: function (a) {
            var b = this.tp;
            if (a != b) {
                this.ti = a;
                this.g3("VolumeTypePickerTemplate", b, this.tp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tk", {
        get: function () {
            return this.td;
        },
        set: function (a) {
            var b = this.tk;
            if (a != b) {
                this.td = a;
                this.g3("IndicatorMenuTemplate", b, this.tk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tl", {
        get: function () {
            return this.te;
        },
        set: function (a) {
            var b = this.tl;
            if (a != b) {
                this.te = a;
                this.g3("OverlayPickerTemplate", b, this.tl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q4", {
        get: function () {
            return this.q3;
        },
        set: function (a) {
            var b = this.q4;
            if (a != b) {
                this.q3 = a;
                this.g3("ZoomSlider", b, this.q4);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cs = function () {
        return _super.prototype.get_cs.call(this);
    };
    FinancialChart.prototype.set_cs = function (a) {
        _super.prototype.set_cs.call(this, a);
    };
    FinancialChart.prototype.get_bq = function () {
        return _super.prototype.get_bq.call(this);
    };
    FinancialChart.prototype.set_bq = function (a) {
        _super.prototype.set_bq.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "sj", {
        get: function () {
            return this.r8;
        },
        set: function (a) {
            var b = this.sj;
            if (a != b) {
                this.r8 = a;
                this.g3("ToolbarHeight", b, this.sj);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.h9 = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.ia = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.q4 != null) {
            this.q4.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.q4 != null) {
            this.q4.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.u = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_b5 = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b5", {
        get: function () {
            return this.get_b5();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_b4 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b4", {
        get: function () {
            return this.get_b4();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.o8 = function (a) {
        return this.o9(a);
    };
    FinancialChart.prototype.qm = function (a) {
        return this.qn(a);
    };
    FinancialChart.prototype.o7 = function (a) {
        var b = this.o8(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.f3 = function () {
        this.xAxis = this.o7("xAxis");
        this.yAxis = this.qm(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.qm(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.o7("volumeXAxis");
        this.rw = new List$1(NumericYAxis.$, 0);
        this.ry = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.qm(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.o7("indicatorXAxis_0");
        this.rw.add(this.indicatorAxis);
        this.ry.add(this.indicatorXAxis);
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeXAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorAxis.aw == null) {
            this.indicatorAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.aw == null) {
            this.indicatorXAxis.aw = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.qm(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.o7("zoomSliderXAxis");
        if (this.zoomSliderAxis.aw == null) {
            this.zoomSliderAxis.aw = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.aw == null) {
            this.zoomSliderXAxis.aw = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.f1 = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.l1 = this.ai(a, b);
        }
    };
    FinancialChart.prototype.hj = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jt = true;
            this.yAxis.kg = 10;
        }
    };
    FinancialChart.prototype.hm = function () {
        this.yAxis.jt = this.rp;
        this.yAxis.kg = this.tb;
    };
    FinancialChart.prototype.pq = function (a) {
        var b;
        if (this.po == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.po;
        }
        b = this.pp(b);
        return b;
    };
    FinancialChart.prototype.pp = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.pz = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ps = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.tx = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.o9 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qn = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qt = function () {
        return this.ar(1);
    };
    FinancialChart.prototype.qu = function () {
        return this.ar(0);
    };
    FinancialChart.prototype.qs = function () {
        return this.ar(2);
    };
    FinancialChart.prototype.qv = function () {
        return this.ar(20);
    };
    Object.defineProperty(FinancialChart.prototype, "ra", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qa", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rd", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p8", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rb", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qc", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rc", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qh", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.aq = function (a, b) {
        var c = this.tx(a);
        switch (this.pq(a)) {
            case 3:
                var d = this.qt();
                this.qa.setValueMemberPath(d, c);
                this.qa.setXAxis(d, this.xAxis);
                this.qa.setYAxis(d, this.yAxis);
                this.qa.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.qu();
                this.qa.setValueMemberPath(e, c);
                this.qa.setXAxis(e, this.xAxis);
                this.qa.setYAxis(e, this.yAxis);
                this.qa.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.qv();
                this.p8.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.p8.setHighMemberPath(f, a.getMemberPathFor(12));
                this.p8.setLowMemberPath(f, a.getMemberPathFor(13));
                this.p8.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.p8.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.p8.setXAxis(f, this.xAxis);
                this.p8.setYAxis(f, this.yAxis);
                this.p8.setDisplayType(f, this.po == 1 ? 1 : 0);
                this.p8.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.hl = function () {
        _super.prototype.hl.call(this);
        this.wg(this.xAxis);
        this.w3(false);
        if (this.pt != 0 && this.volumeChart != null) {
            this.wm();
        }
        this.wg(this.volumeXAxis);
        this.wg(this.indicatorXAxis);
        this.w0();
        this.w2();
        if (this.p0 != 0) {
            this.wn();
            this.wg(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.m8 = function (a, b) {
        var e_1, _a;
        _super.prototype.m8.call(this, a, b);
        a(this.volumeXAxis);
        if (this.ry != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.ry)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.nc = function (a, b) {
        var e_2, _a;
        _super.prototype.nc.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.rw != null) {
                try {
                    for (var _b = tslib_1.__values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.na = function (a) {
        _super.prototype.na.call(this, a);
        this.m2(this.volumeXAxis, a);
        this.m2(this.indicatorXAxis, a);
        this.m2(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ne = function (a) {
        _super.prototype.ne.call(this, a);
        this.m2(this.volumeAxis, a);
        this.m2(this.indicatorAxis, a);
        this.m2(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.nd = function (a) {
        _super.prototype.nd.call(this, a);
        this.m1(this.volumeAxis, a);
        this.m1(this.indicatorAxis, a);
        this.m1(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.m9 = function (a) {
        _super.prototype.m9.call(this, a);
        this.m1(this.volumeXAxis, a);
        this.m1(this.indicatorXAxis, a);
        this.m1(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.gf = function (a) {
        var _this = this;
        _super.prototype.gf.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nr = a.nt = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.m9 = this.dataChart.m9;
                a.nc = this.dataChart.nc;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.ur();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    };
    FinancialChart.prototype.ur = function () {
        if (this.tq == null) {
            FinancialChart.ta++;
            this.tq = FinancialChart.ta.toString();
        }
        return this.tq;
    };
    FinancialChart.prototype.v2 = function (a, b) {
        this.vo();
        this.wi();
    };
    FinancialChart.prototype.vo = function () {
        var e_3, _a;
        if (this.yAxis.bz()) {
            return;
        }
        var a = this.yAxis.at.a5;
        if (this.pt != 0) {
            a = Math.max(a, this.volumeAxis.at.a5);
        }
        try {
            for (var _b = tslib_1.__values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.at.a5);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.vp(a);
    };
    FinancialChart.prototype.vp = function (a) {
        var e_4, _a;
        if (this.yAxis.bz()) {
            return;
        }
        this.yAxis.d4 = this.volumeAxis.d4 = a;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.d4 = a;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.zoomSliderAxis.d4 = this.yAxis.d4;
    };
    FinancialChart.prototype.vu = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.vx = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.vv = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.rh(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.vw = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rh(d)) {
                continue;
            }
            var e = this.s4(d, c);
            a(d, e);
        }
        if (b) {
            this.vy(a);
        }
    };
    FinancialChart.prototype.vy = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.s4 = function (a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        var c = this.v == null || this.v.dataSeries == null ? 0 : this.v.dataSeries.count;
        var d = this.p4 == null ? 0 : this.p4.count;
        return b - (c * d);
    };
    FinancialChart.prototype.f9 = function (a) {
        _super.prototype.f9.call(this, a);
        this.vx(a);
        this.vu(a);
        this.vy(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.qz;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.qz = a;
                this.g3("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.wm = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rh(d) || d.cj) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.pt;
            f = this.ps(f);
            switch (f) {
                case 2:
                    e = this.qu();
                    break;
                case 3:
                    e = this.qs();
                    break;
                default:
                case 1:
                    e = this.qt();
                    break;
            }
            this.qa.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.qa.setXAxis(e, this.volumeXAxis);
            this.qa.setYAxis(e, this.volumeAxis);
            this.qa.setValueMemberPath(e, this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > b ? this.v.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fx = d.fx + " Volume";
            e.k5 = ArrayExtension.getModulus$1(Brush.$, this.o1, b);
            e.k8 = ArrayExtension.getModulus$1(Brush.$, this.o2, b);
            e.ey = this.sk;
            a.add(e);
        }
        var g = this.b1("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.gk(i, h);
        }
    };
    FinancialChart.prototype.re = function (a) {
        if (!this.ra) {
            return false;
        }
        return this.qa.matchesType(a);
    };
    FinancialChart.prototype.ri = function (a) {
        if (!this.rd) {
            return false;
        }
        return this.p8.matchesType(a);
    };
    FinancialChart.prototype.rf = function (a) {
        if (!this.rb) {
            return false;
        }
        return this.qc.matchesType(a);
    };
    FinancialChart.prototype.rh = function (a) {
        if (!this.rc) {
            return false;
        }
        return this.qh.matchesType(a);
    };
    FinancialChart.prototype.wl = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.p2 == null ? 0 : this.p2.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.p2._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.rh(l) || l.cj) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.qw("Custom");
                    this.qc.handleCustomIndicatorEvent(n, runOn(this, this.v0));
                    m = n;
                }
                else {
                    m = this.qy(this.p2._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.qc.setXAxis(m, this.ry._inner[e]);
                this.qc.setYAxis(m, this.rw._inner[e]);
                m.itemsSource = l.itemsSource;
                this.qc.setOpenMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(11));
                this.qc.setHighMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(12));
                this.qc.setLowMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(13));
                this.qc.setCloseMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(14));
                this.qc.setVolumeMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(15));
                m.fx = l.fx + " " + i;
                m.k5 = ArrayExtension.getModulus$1(Brush.$, this.ov, e);
                m.ey = this.sh;
                if (this.rf(m)) {
                    this.qc.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ow, e));
                    this.qc.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.qe, e));
                }
                if (this.s6 != -2147483648 && this.rf(m)) {
                    this.qc.setPeriodOverride(m, this.s6);
                }
                if (this.rf(m)) {
                    this.qc.setSmoothingPeriod(m, this.s9);
                }
                if (this.rf(m)) {
                    this.qc.setSignalPeriod(m, this.s8);
                }
                if (this.rf(m)) {
                    this.qc.setShortPeriod(m, this.s7);
                    this.qc.setLongPeriod(m, this.s5);
                }
                this.gk(m, e);
                f.add(m);
            }
            var o = this.b1(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.gk(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.qw = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.qy = function (a) {
        return this.qw(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.w3 = function (a) {
        if (this.pm == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.pm.as = b.actualMinimumValue;
        this.pm.ar = b.actualMaximumValue;
        if (a) {
            this.pm.au = b.visibleMinimum;
            this.pm.at = b.visibleMaximum;
        }
        this.pm.bn();
    };
    FinancialChart.prototype.dj = function () {
        var e_5, _a, e_6, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.dj.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.oe();
            $ret.toolbar = _this.pm == null ? null : _this.pm.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.oe();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = tslib_1.__values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.oe());
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.xc(this.dataChart).x;
            a.mainChartTop = this.xc(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.xc(this.volumeChart).x;
            a.volumeChartTop = this.xc(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.xc(this.zoomSliderChart).x;
            a.zoomChartTop = this.xc(this.zoomSliderChart).y;
        }
        if (this.pm != null) {
            var c = this.xd(this.pm);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = tslib_1.__values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.xc(d).x);
                    a.indicatorChartTops.add(this.xc(d).y);
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        var e = this.xf();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.p6 == null ? null : this.p6.exportVisualData();
        return a;
    };
    FinancialChart.prototype.tv = function () {
        var a = this.dj();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.qx = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.w2 = function () {
        var e_7, _a, e_8, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.rh(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_7) throw e_7.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_8) throw e_8.error; }
        }
        if (this.p4 == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.rh(g) || g.cj) {
                continue;
            }
            e++;
            for (var h = 0; h < this.p4.count; h++) {
                var i = this.p4._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.qx(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.qx(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.qh.setXAxis(j, this.xAxis);
                this.qh.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.p4.count + h;
                j.k5 = ArrayExtension.getModulus$1(Brush.$, this.oz, k);
                j.k8 = ArrayExtension.getModulus$1(Brush.$, this.o0, k);
                j.ey = this.si;
                j.fx = g.fx + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.v.dataSeries._inner[e];
                this.qh.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.qh.setHighMemberPath(j, m.getMemberPathFor(12));
                this.qh.setLowMemberPath(j, m.getMemberPathFor(13));
                this.qh.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.qh.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].fh = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.gk(q, p);
        }
    };
    FinancialChart.prototype.w0 = function () {
        var e_9, _a;
        if (this.rn) {
            return;
        }
        this.rn = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = tslib_1.__values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.wh(b);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
        if ((this.p2 == null || this.p2.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.rw != null) {
                this.rw.clear();
            }
            if (this.ry != null) {
                this.ry.clear();
            }
            this.wr();
            this.w1();
            this.rn = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.rw.clear();
        this.ry.clear();
        var c = this.p2 == null ? 0 : this.p2.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.wf(g);
            var h = f >= c;
            g.gq = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.p2._inner[f]);
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b5) {
                        j = this.o8(0);
                    }
                    else {
                        j = this.o8(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.rw.add(i);
                this.ry.add(j);
                if (this.bh) {
                    this.m5(i);
                }
                if (this.bh) {
                    this.m3(j);
                }
            }
        }
        this.wl();
        this.wr();
        if (this.pm != null) {
            this.pm.ae = this.p2;
        }
        this.vq();
        this.w1();
        this.rn = false;
    };
    FinancialChart.prototype.gc = function () {
        var e_10, _a, e_11, _b;
        _super.prototype.gc.call(this);
        this.m3(this.xAxis);
        this.m3(this.volumeXAxis);
        if (this.ry != null) {
            try {
                for (var _c = tslib_1.__values(fromEnum(this.ry)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.m3(a);
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_10) throw e_10.error; }
            }
        }
        this.m5(this.yAxis);
        this.m5(this.volumeAxis);
        if (this.rw != null) {
            try {
                for (var _e = tslib_1.__values(fromEnum(this.rw)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.m5(b);
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        this.m3(this.zoomSliderXAxis);
        this.m5(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_bv = function () {
        return !this.rl;
    };
    Object.defineProperty(FinancialChart.prototype, "rr", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.w8 = function (a, b) {
        this.wu(a, b);
        this.vq();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.wn();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.ws();
        this.w9(a, b);
    };
    FinancialChart.prototype.wn = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.rh(c) || c.cj) {
                continue;
            }
            var d = void 0;
            var e = this.p0;
            e = this.pz(e);
            var f = this.s4(c, b);
            if (e == 1) {
                switch (this.pq(this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.qv();
                    this.p8.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.qv();
                    this.p8.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.qu();
                    break;
                case 6:
                    d = this.qs();
                    break;
                default:
                case 4:
                    d = this.qt();
                    break;
            }
            var g = this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null;
            if (d.cl && !d.cr) {
                this.qa.setCategoryMode(d, 1);
                this.qa.setXAxis(d, this.zoomSliderXAxis);
                this.qa.setYAxis(d, this.zoomSliderAxis);
                this.qa.setValueMemberPath(d, g == null ? null : this.tx(g));
            }
            else if (d.cr) {
                this.p8.setCategoryMode(d, 1);
                this.p8.setXAxis(d, this.zoomSliderXAxis);
                this.p8.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.p8.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.p8.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.p8.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.p8.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.p8.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.fx = c.fx;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.gk(i, h);
        }
    };
    FinancialChart.prototype.gz = function (a, b, c) {
        var e_12, _a;
        _super.prototype.gz.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.v0 = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.p2 == null ? 0 : this.p2.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.ww = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bh) {
            this.m3(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rq", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.v1 = function (a, b) {
        this.w0();
    };
    FinancialChart.prototype.rj = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.wq = function () {
        var e_13, _a;
        var a = this.pk != null ? this.pk : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = tslib_1.__values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.rj(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_13) throw e_13.error; }
        }
        this.pj = b;
        if (this.pm != null) {
            this.pm.u = this.pj;
        }
    };
    FinancialChart.prototype.v5 = function (a, b) {
        this.wq();
    };
    FinancialChart.prototype.wa = function (a, b) {
        this.p4 = this.pm.ag;
    };
    FinancialChart.prototype.v9 = function (a, b) {
        this.p2 = this.pm.ae;
    };
    FinancialChart.prototype.v3 = function (a, b) {
        this.w0();
    };
    FinancialChart.prototype.v4 = function (a, b) {
        this.w2();
    };
    FinancialChart.prototype.we = function (a, b) {
        var c = a;
        if (c.bd == null) {
            return;
        }
        if (this.rl) {
            this.wp(c.bd);
        }
    };
    FinancialChart.prototype.wh = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.v2));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d4 = this.volumeAxis.d4 = this.indicatorAxis.d4 = 0;
            this.xAxis.aw.visibility = this.ol;
        }
    };
    FinancialChart.prototype.wf = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.m4 = new Rect(0, this.dataChart.mq.x, a.m4.y, this.dataChart.mq.width, a.m4.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.v2));
        this.ge(a);
    };
    FinancialChart.prototype.vq = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.m1(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.ry._inner[a];
            var c = a < this_1.ry.count - 1 || this_1.volumeChart != null;
            this_1.m1(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.ry.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.wu = function (a, b) {
        if (a != null) {
            this.wh(a);
        }
        if (b != null) {
            this.wf(b);
        }
    };
    FinancialChart.prototype.w6 = function (a, b) {
        this.wu(a, b);
        this.vq();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.wm();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.w7(a, b);
    };
    FinancialChart.prototype.v6 = function (a, b) {
        this.w4();
    };
    FinancialChart.prototype.w4 = function () {
        if (this.pm == null || +(this.pm.au) == +(dateMaxValue()) || +(this.pm.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.pm.au, this.pm.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.rm = true;
        this.dataChart.m4 = new Rect(0, b.left, this.dataChart.m4.top, b.width, this.dataChart.m4.height);
        if (this.q4 != null) {
            this.q4.windowRect = this.dataChart.mq;
        }
        if (this.rl) {
            this.wp(this.dataChart);
        }
        this.rm = false;
    };
    FinancialChart.prototype.wd = function (a, b) {
        this.wq();
        this.w3(!this.rm);
    };
    FinancialChart.prototype.vz = function (a, b) {
        var _this = this;
        if (!this.rm) {
            if (this.rl) {
                this.wp(a);
            }
            var c = false;
            var d = this.g8(function () { return _this.w3(true); }, c);
            c = d.p1;
            if (this.q4 != null) {
                this.q4.windowRect = this.dataChart.mq;
            }
        }
    };
    FinancialChart.prototype.wy = function (a, b, c, d) {
        var e_14, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.rm = true;
            a.m4 = new Rect(0, d, a.mq.top, c, a.mq.height);
            this.rm = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.b8, a.mu);
        try {
            for (var _b = tslib_1.__values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.eh();
                var j = i.ao();
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dw(j.c, h);
                var m = b.dw(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_14) throw e_14.error; }
        }
        var n = a.mq.width;
        if (c != -1) {
            n = c;
        }
        var o = a.mq.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.rm = true;
        var p = new Rect(0, o, e, n, f - e);
        a.m4 = p;
        this.rm = false;
    };
    FinancialChart.prototype.wx = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.wy(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.wy(this.volumeChart, this.volumeAxis, this.dataChart.mq.width, this.dataChart.mq.left);
            }
        }
        else if (a == this.volumeChart) {
            this.wy(this.volumeChart, this.volumeAxis, -1, -1);
            this.wy(this.dataChart, this.yAxis, this.volumeChart.mq.width, this.volumeChart.mq.left);
        }
    };
    FinancialChart.prototype.wp = function (a) {
        var _this = this;
        this.g7(function () { return _this.wx(a); });
    };
    FinancialChart.prototype.v7 = function (a, b) {
        if (this.rl) {
            this.wp(a);
        }
    };
    FinancialChart.prototype.w5 = function () {
        if (!this.rr) {
            return;
        }
        this.vt();
        if (this.p0 == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.wn();
        }
    };
    FinancialChart.prototype.vt = function () {
        var container_ = this.sw.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.q4 != null && containerParent_ != null && !this.rs) {
            this.rs = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.q4;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.wz = function () {
        var _this = this;
        if (this.pv != 1) {
            return;
        }
        this.m7(function (a) {
            var e_15, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = tslib_1.__values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_15) throw e_15.error; }
            }
        });
    };
    FinancialChart.prototype.hq = function (a, b, c) {
        _super.prototype.hq.call(this, a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (this.pv == 1 && stringIsNullOrEmpty(this.ea)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.ec)) {
                this.ac.setYMemberPath(a, this.tx(c));
            }
            if (stringIsNullOrEmpty(this.d6)) {
                this.ac.setLabelMemberPath(a, this.tx(c));
            }
            if (stringIsNullOrEmpty(this.d3)) {
                this.ac.setContentMemberPath(a, this.tx(c));
            }
        }
    };
    FinancialChart.prototype.m3 = function (a) {
        var e_16, _a;
        _super.prototype.m3.call(this, a);
        var b = a;
        this.wg(b);
        if (a.bd != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(a.bd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.re(c)) {
                        this.qa.setXAxis(c, b);
                    }
                    else if (this.ri(c)) {
                        this.p8.setXAxis(c, b);
                    }
                    else if (this.rf(c)) {
                        this.qc.setXAxis(c, b);
                    }
                    else if (this.rh(c)) {
                        this.qh.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_16) throw e_16.error; }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.ij = this.xb;
            a.d3 = this.sr;
            this.m1(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.r4;
        e.maximumValue = this.r3;
    };
    FinancialChart.prototype.m5 = function (a) {
        var e_17, _a;
        _super.prototype.m5.call(this, a);
        if (a.bd != null && a == this.yAxis) {
            try {
                for (var _b = tslib_1.__values(fromEnum(a.bd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.re(b)) {
                        this.qa.setYAxis(b, this.yAxis);
                    }
                    else if (this.ri(b)) {
                        this.p8.setYAxis(b, this.yAxis);
                    }
                    else if (this.rf(b)) {
                        this.qc.setYAxis(b, this.yAxis);
                    }
                    else if (this.rh(b)) {
                        this.qh.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) { e_17 = { error: e_17_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_17) throw e_17.error; }
            }
        }
        a.jo = this.ro;
        a.kc = this.sp;
        a.kb = this.so;
        if (a == this.yAxis) {
            a.j8 = this.sn;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.m1(a, function (d) { return d.visibility = 1; });
        }
    };
    FinancialChart.prototype.wg = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e7 = XYChart.kx(a, this.v.dataSeries);
        if (this.v.dataSeries.count > 0) {
            var b = this.v.dataSeries._inner[0].getMemberPathFor(17);
            a.gw(b);
        }
    };
    FinancialChart.prototype.gk = function (a, b) {
        _super.prototype.gk.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cz) {
            a.ji(this.ox != null ? ArrayExtension.getModulus$1(Brush.$, this.ox, b) : null, this.oy != null ? ArrayExtension.getModulus$1(Brush.$, this.oy, b) : null);
        }
        var d = this.zoomSliderChart == a.bq;
        var e = this.rf(a);
        if (this.rh(a)) {
            a.k5 = this.oz != null ? ArrayExtension.getModulus$1(Brush.$, this.oz, b) : null;
            a.k8 = this.o0 != null ? ArrayExtension.getModulus$1(Brush.$, this.o0, b) : null;
            a.ey = this.si;
        }
        else if (e) {
            a.k5 = this.ov != null ? ArrayExtension.getModulus$1(Brush.$, this.ov, b) : null;
            a.ey = this.sh;
        }
        else if (!a.cj && (c || d)) {
            a.k5 = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.k8 = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.bq;
        if (f) {
            a.ey = this.sk;
        }
        a.legend = d || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.rg ? this.p6 : null;
    };
    FinancialChart.prototype.g3 = function (a, b, c) {
        var e_18, _a, e_19, _b;
        var _this = this;
        _super.prototype.g3.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.jt = this.rp;
                if (this.volumeAxis != null) {
                    this.volumeAxis.jt = this.rp;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.jt = this.rp;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kg = this.tb;
                if (this.volumeAxis != null) {
                    this.volumeAxis.kg = this.tb;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.kg = this.tb;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.pt == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.wm();
                }
                break;
            case "VolumeChart":
                this.w6(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.v2));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.vz));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.v7));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.v2));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.vz));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.v7));
                }
                this.w5();
                break;
            case "XAxisMode":
                this.xAxis = this.o8(this.pv);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.o8(this.pv);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.o8(this.pv);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.o8(this.pv);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.m1(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.vq();
                if (this.pv == 1) {
                    this.wz();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.qm(this.px);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.qm(this.px);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.qm(this.px);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.v6));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.v9));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.wa));
                }
                if (this.pm != null) {
                    this.pm.ae = this.p2;
                    this.pm.ag = this.p4;
                    this.pm.u = this.pj;
                    this.w3(true);
                    var j = this.pm;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.v6));
                    var k = this.pm;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.v9));
                    var l = this.pm;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.wa));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.wd));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bh) {
                    this.m3(this.xAxis);
                    this.f7();
                }
                this.w3(false);
                this.w4();
                this.wq();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.wd));
                break;
            case "ChartType":
                this.hl();
                break;
            case "VolumeXAxis":
                this.ww(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.ww(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.w0();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bh) {
                    this.m5(this.yAxis);
                    this.m5(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.we));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.wm();
                }
                if (this.bh) {
                    this.m5(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.we));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_18 = void 0, tslib_1.__values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) { e_18 = { error: e_18_1 }; }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                            }
                            finally { if (e_18) throw e_18.error; }
                        }
                        try {
                            for (var _e = (e_19 = void 0, tslib_1.__values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) { e_19 = { error: e_19_1 }; }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                            }
                            finally { if (e_19) throw e_19.error; }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.px == 1) {
                            y = this.qm(this.px);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bh) {
                            this.m5(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nt = this.bw && this.bv;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nt = this.bw && this.bv;
                }
                if (this.rl) {
                    this.wx(this.dataChart);
                }
                else {
                    this.volumeChart.oc = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.v3));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.v3));
                }
                this.w0();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.v4));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.v4));
                }
                this.w2();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.nb(function (ad) { return ad.jo = _this.ro; });
                break;
            case "YAxisMinimumValue":
                this.nc(function (ad) { return ad.kc = _this.sp; }, false);
                break;
            case "YAxisMaximumValue":
                this.nc(function (ad) { return ad.kb = _this.so; }, false);
                break;
            case "YAxisInterval":
                this.nc(function (ad) { return ad.j8 = _this.sn; }, false);
                break;
            case "ZoomSliderType":
                this.w5();
                break;
            case "ZoomSliderChart":
                if (!this.rq) {
                    return;
                }
                this.w8(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.vw(function (ad, ae) {
                    if (ad.cz) {
                        ad.ji(_this.ox != null ? ArrayExtension.getModulus$1(Brush.$, _this.ox, ae) : null, _this.oy != null ? ArrayExtension.getModulus$1(Brush.$, _this.oy, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.k5 = _this.oz != null ? ArrayExtension.getModulus$1(Brush.$, _this.oz, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.k8 = _this.o0 != null ? ArrayExtension.getModulus$1(Brush.$, _this.o0, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.ey = _this.si;
                });
                break;
            case "VolumeBrushes":
                this.vx(function (ad, ae) { return ad.k5 = ArrayExtension.getModulus$1(Brush.$, _this.o1, ae); });
                break;
            case "VolumeOutlines":
                this.vx(function (ad, ae) { return ad.k8 = ArrayExtension.getModulus$1(Brush.$, _this.o2, ae); });
                break;
            case "VolumeThickness":
                this.vx(function (ad, ae) { return ad.ey = _this.sk; });
                break;
            case "IndicatorNegativeBrushes":
                this.vu(function (ad, ae) { return _this.qc.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.ow, ae)); });
                break;
            case "IndicatorBrushes":
                this.vu(function (ad, ae) { return ad.k5 = ArrayExtension.getModulus$1(Brush.$, _this.ov, ae); });
                break;
            case "IndicatorThickness":
                this.vu(function (ad, ae) { return ad.ey = _this.sh; });
                break;
            case "IndicatorDisplayTypes":
                this.vu(function (ad, ae) { return _this.qc.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.qe, ae)); });
                break;
            case "IndicatorPeriod":
                this.vu(function (ad, ae) {
                    if (_this.s6 == -2147483648 || !(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setPeriodOverride(ad, _this.s6);
                });
                break;
            case "IndicatorMultiplier":
                this.vu(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    _this.qh.setMultiplier(ad, _this.sg);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setSmoothingPeriod(ad, _this.s9);
                });
                break;
            case "IndicatorShortPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setShortPeriod(ad, _this.s7);
                });
                break;
            case "IndicatorLongPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setLongPeriod(ad, _this.s5);
                });
                break;
            case "IndicatorSignalPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setSignalPeriod(ad, _this.s8);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.v5));
                }
                if (this.pk != null) {
                    var ae = this.pk;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.v5));
                }
                this.wq();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.v1));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.v1));
                }
                this.w0();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.vw(function (ah, ai) { return ah.k5 = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null; }, true);
                break;
            case "Outlines":
                this.vw(function (ah, ai) { return ah.k8 = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ol == 0 && this.zoomSliderXAxis != null) {
                    this.m1(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.vq();
                break;
            case "YAxisLabelVisibility":
                if (this.om != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.m1(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.ij = this.xb;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d3 = this.sr;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.rg && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.p6 : null;
                        }
                    };
                    this.vw(ai, false);
                    this.vv(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.wn();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bh) {
                        this.m5(this.zoomSliderAxis);
                    }
                    this.m1(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.m7(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.r4;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.m7(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.r3;
                    }
                });
                break;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rp", {
        get: function () {
            return this.q9;
        },
        set: function (a) {
            var b = this.rp;
            if (a != b) {
                this.q9 = a;
                this.g3("YAxisIsLogarithmic", b, this.rp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tb", {
        get: function () {
            return this.s3;
        },
        set: function (a) {
            var b = this.tb;
            if (a != b) {
                this.s3 = a;
                this.g3("YAxisLogarithmBase", b, this.tb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sn", {
        get: function () {
            return this.sa;
        },
        set: function (a) {
            var b = this.sn;
            if (a != b) {
                this.sa = a;
                this.g3("YAxisInterval", b, this.sn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sp", {
        get: function () {
            return this.sc;
        },
        set: function (a) {
            var b = this.sp;
            if (a != b) {
                this.sc = a;
                this.g3("YAxisMinimumValue", b, this.sp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "so", {
        get: function () {
            return this.sb;
        },
        set: function (a) {
            var b = this.so;
            if (a != b) {
                this.sb = a;
                this.g3("YAxisMaximumValue", b, this.so);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sq", {
        get: function () {
            return this.sd;
        },
        set: function (a) {
            var b = this.sq;
            if (a != b) {
                this.sd = a;
                this.g3("YAxisMinorInterval", b, this.sq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sm", {
        get: function () {
            return this.yAxis.j4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sl", {
        get: function () {
            return this.yAxis.j3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pt", {
        get: function () {
            return this.pr;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.pr = a;
                this.g3("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.pt));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pv", {
        get: function () {
            return this.pu;
        },
        set: function (a) {
            var b = this.pv;
            if (a != b) {
                this.pu = a;
                this.g3("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.pv));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "px", {
        get: function () {
            return this.pw;
        },
        set: function (a) {
            var b = this.px;
            if (a != b) {
                this.pw = a;
                this.g3("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.px));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rk", {
        get: function () {
            return this.q6;
        },
        set: function (a) {
            var b = this.rk;
            if (a != b) {
                this.q6 = a;
                this.g3("IsToolbarVisible", b, this.rk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "po", {
        get: function () {
            return this.pn;
        },
        set: function (a) {
            var b = this.po;
            if (a != b) {
                this.pn = a;
                this.g3("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.po));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_nk = function () {
        return _super.prototype.get_nk.call(this);
    };
    FinancialChart.prototype.set_nk = function (a) {
        _super.prototype.set_nk.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "rl", {
        get: function () {
            return this.q7;
        },
        set: function (a) {
            var b = this.rl;
            if (a != b) {
                this.q7 = a;
                this.g3("IsWindowSyncedToVisibleRange", b, this.rl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p2", {
        get: function () {
            return this.p1;
        },
        set: function (a) {
            var b = this.p2;
            if (a != b) {
                this.p1 = a;
                this.g3("IndicatorTypes", b, this.p2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p4", {
        get: function () {
            return this.p3;
        },
        set: function (a) {
            var b = this.p4;
            if (a != b) {
                this.p3 = a;
                this.g3("OverlayTypes", b, this.p4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.ru;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.ru = a;
                this.g3("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ro", {
        get: function () {
            return this.q8;
        },
        set: function (a) {
            var b = this.ro;
            if (a != b) {
                this.q8 = a;
                this.g3("YAxisAbbreviateLargeNumbers", b, this.ro);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cu = function () {
        return _super.prototype.get_cu.call(this);
    };
    FinancialChart.prototype.set_cu = function (a) {
        _super.prototype.set_cu.call(this, a);
    };
    FinancialChart.prototype.get_ih = function () {
        return _super.prototype.get_ih.call(this);
    };
    FinancialChart.prototype.set_ih = function (a) {
        _super.prototype.set_ih.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.q0 = a;
                this.g3("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.ql;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.ql = a;
                this.g3("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.o6;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.o6 = a;
                this.g3("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p0", {
        get: function () {
            return this.py;
        },
        set: function (a) {
            var b = this.p0;
            if (a != b) {
                this.py = a;
                this.g3("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.p0));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ox", {
        get: function () {
            return this.op;
        },
        set: function (a) {
            var b = this.ox;
            if (a != b) {
                this.op = a;
                this.g3("NegativeBrushes", b, this.ox);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oy", {
        get: function () {
            return this.oq;
        },
        set: function (a) {
            var b = this.oy;
            if (a != b) {
                this.oq = a;
                this.g3("NegativeOutlines", b, this.oy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oz", {
        get: function () {
            return this.or;
        },
        set: function (a) {
            var b = this.oz;
            if (a != b) {
                this.or = a;
                this.g3("OverlayBrushes", b, this.oz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o0", {
        get: function () {
            return this.os;
        },
        set: function (a) {
            var b = this.o0;
            if (a != b) {
                this.os = a;
                this.g3("OverlayOutlines", b, this.o0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o2", {
        get: function () {
            return this.ou;
        },
        set: function (a) {
            var b = this.o2;
            if (a != b) {
                this.ou = a;
                this.g3("VolumeOutlines", b, this.o2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o1", {
        get: function () {
            return this.ot;
        },
        set: function (a) {
            var b = this.o1;
            if (a != b) {
                this.ot = a;
                this.g3("VolumeBrushes", b, this.o1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ow", {
        get: function () {
            return this.oo;
        },
        set: function (a) {
            var b = this.ow;
            if (a != b) {
                this.oo = a;
                this.g3("IndicatorNegativeBrushes", b, this.ow);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ov", {
        get: function () {
            return this.on;
        },
        set: function (a) {
            var b = this.ov;
            if (a != b) {
                this.on = a;
                this.g3("IndicatorBrushes", b, this.ov);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sk", {
        get: function () {
            return this.r9;
        },
        set: function (a) {
            var b = this.sk;
            if (a != b) {
                this.r9 = a;
                this.g3("VolumeThickness", b, this.sk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "si", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.si;
            if (a != b) {
                this.r7 = a;
                this.g3("OverlayThickness", b, this.si);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sh", {
        get: function () {
            return this.r6;
        },
        set: function (a) {
            var b = this.sh;
            if (a != b) {
                this.r6 = a;
                this.g3("IndicatorThickness", b, this.sh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qe", {
        get: function () {
            return this.qd;
        },
        set: function (a) {
            var b = this.qe;
            if (a != b) {
                this.qd = a;
                this.g3("IndicatorDisplayTypes", b, this.qe);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s6", {
        get: function () {
            return this.sz;
        },
        set: function (a) {
            var b = this.s6;
            if (a != b) {
                this.sz = a;
                this.g3("IndicatorPeriod", b, this.s6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sg", {
        get: function () {
            return this.r5;
        },
        set: function (a) {
            var b = this.sg;
            if (a != b) {
                this.r5 = a;
                this.g3("IndicatorMultiplier", b, this.sg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s9", {
        get: function () {
            return this.s2;
        },
        set: function (a) {
            var b = this.s9;
            if (a != b) {
                this.s2 = a;
                this.g3("IndicatorSmoothingPeriod", b, this.s9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s7", {
        get: function () {
            return this.s0;
        },
        set: function (a) {
            var b = this.s7;
            if (a != b) {
                this.s0 = a;
                this.g3("IndicatorShortPeriod", b, this.s7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s5", {
        get: function () {
            return this.sy;
        },
        set: function (a) {
            var b = this.s5;
            if (a != b) {
                this.sy = a;
                this.g3("IndicatorLongPeriod", b, this.s5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s8", {
        get: function () {
            return this.s1;
        },
        set: function (a) {
            var b = this.s8;
            if (a != b) {
                this.s1 = a;
                this.g3("IndicatorSignalPeriod", b, this.s8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pk", {
        get: function () {
            return this.pi;
        },
        set: function (a) {
            var b = this.pk;
            if (a != b) {
                this.pi = a;
                this.g3("RangeSelectorOptions", b, this.pk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.pe;
        },
        set: function (a) {
            var b = this.pe;
            if (a != b) {
                this.pe = a;
                this.g3("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_bw = function () {
        return _super.prototype.get_bw.call(this);
    };
    FinancialChart.prototype.set_bw = function (a) {
        _super.prototype.set_bw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "xb", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = this.xb;
            if (a != b) {
                this.xa = a;
                this.g3("ZoomSliderXAxisMajorStroke", b, this.xb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sr", {
        get: function () {
            return this.se;
        },
        set: function (a) {
            var b = this.sr;
            if (a != b) {
                this.se = a;
                this.g3("ZoomSliderXAxisMajorStrokeThickness", b, this.sr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rg", {
        get: function () {
            return this.q5;
        },
        set: function (a) {
            var b = this.rg;
            if (a != b) {
                this.q5 = a;
                this.g3("IsLegendVisible", b, this.rg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p6", {
        get: function () {
            return this.p5;
        },
        set: function (a) {
            var b = this.p6;
            if (a != b) {
                this.p5 = a;
                this.g3("FinancialChartLegend", b, this.p6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.o5;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.o5 = a;
                this.g3("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.qk;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.qk = a;
                this.g3("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.qj;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.qj = a;
                this.g3("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.o4;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.o4 = a;
                this.g3("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.qi;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.qi = a;
                this.g3("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.o3;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.o3 = a;
                this.g3("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rw", {
        get: function () {
            return this.rt;
        },
        set: function (a) {
            var b = this.rw;
            if (a != b) {
                this.rt = a;
                this.g3("IndicatorAxes", b, this.rw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ry", {
        get: function () {
            return this.rv;
        },
        set: function (a) {
            var b = this.ry;
            if (a != b) {
                this.rv = a;
                this.g3("IndicatorXAxes", b, this.ry);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r4", {
        get: function () {
            return this.r2;
        },
        set: function (a) {
            var b = this.r4;
            if (+a != +b) {
                this.r2 = a;
                this.g3("XAxisMinimumValue", b, this.r4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r3", {
        get: function () {
            return this.r1;
        },
        set: function (a) {
            var b = this.r3;
            if (+a != +b) {
                this.r1 = a;
                this.g3("XAxisMaximumValue", b, this.r3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.rz;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ta = 0;
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.tm : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.tj : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.tk : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_20, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = tslib_1.__values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_20_1) { e_20 = { error: e_20_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_20) throw e_20.error; }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.e(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.d(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.c(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.af();
        }
        if (this.p != null) {
            this.p.g(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map