import { ensureBool } from "igniteui-angular-core";
/**
 * Contains PieChart click event data.
*/
var IgxSliceClickEventArgs = /** @class */ (function () {
    function IgxSliceClickEventArgs() {
    }
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSliceClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxSliceClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isSelected", {
        /**
         * Gets or sets whether the slice is selected.
        */
        get: function () {
            return this.i.isSelected;
        },
        set: function (v) {
            this.i.isSelected = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isExploded", {
        /**
         * Gets or sets whether the slice is exploded.
        */
        get: function () {
            return this.i.isExploded;
        },
        set: function (v) {
            this.i.isExploded = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isOthersSlice", {
        /**
         * Gets whether the current slice is part of the others slice.
        */
        get: function () {
            return this.i.isOthersSlice;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "dataContext", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.dataContext;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "originalEvent", {
        /**
         * Holds a reference to the original event that triggered slice click.
        */
        get: function () {
            return this.i.originalEvent;
        },
        set: function (v) {
            this.i.originalEvent = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxSliceClickEventArgs;
}());
export { IgxSliceClickEventArgs };
//# sourceMappingURL=igx-slice-click-event-args.js.map