import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting } from "igniteui-angular-core";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class AreaSeries extends HorizontalAnchoredCategorySeries implements IUnknownValuePlotting {
    static $t: Type;
    protected bf(): SeriesView;
    protected ng(): CategoryTransitionInMode;
    iu(a: SeriesView): void;
    qh: AreaSeriesView;
    protected get_ck(): boolean;
    constructor();
    qi: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    dh(a: Point, b: boolean): boolean;
    hv(a: boolean, b: SeriesView): void;
    oo(a: CategoryFrame, b: CategorySeriesView): void;
    unknownValuePlotting: UnknownValuePlotting;
    protected iz(a: any, b: string, c: any, d: any): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AreaSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected c6: AreaSeries;
    constructor(a: AreaSeries);
    ap(): void;
    readonly de: Path;
    readonly df: Path;
    readonly dh: Path;
    readonly dj: Path;
    private dg;
    private dk;
    private di;
    private dl;
    c7(): void;
    c8(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c9(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private da;
    private dc;
    private db;
    private dd;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
}
