import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FastStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_qc(): IndicatorCalculationStrategy;
    protected readonly qc: IndicatorCalculationStrategy;
    protected get_qp(): Type;
    protected readonly qp: Type;
    qx: number;
    static readonly qy: DependencyProperty;
    protected qi(): number;
    qr(a: number): void;
}
