import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { Style } from "igniteui-angular-core";
import { MarkerType } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Rect } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { DataContext } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { IDictionary$2 } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { FrameworkElement } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { Size } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterPolygonSeries extends ShapeSeriesBase {
    static $t: Type;
    constructor();
    protected mh(): boolean;
    protected mz(a: SeriesView): void;
    private nj;
    protected bf(): SeriesView;
    iu(a: SeriesView): void;
    ng: ScatterPolygonSeriesView;
    nh: ShapeAxisInfoCache;
    private static od;
    private ne;
    private nf;
    protected get_hasMarkers(): boolean;
    k6(): Brush;
    k7(): Brush;
    jz(): DataTemplate;
    ni: StyleSelector;
    of: Style;
    nd: MarkerType;
    nx: DataTemplate;
    nw: DataTemplate;
    ob: Brush;
    n9: Brush;
    oc: Brush;
    oa: Brush;
    oe: Style;
    nc: CollisionAvoidanceType;
    protected jo(): void;
    protected iz(a: any, b: string, c: any, d: any): void;
    ar(a: Point, b: boolean): DataContext;
    nv(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    nb(a: ScatterPolygonSeriesView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    na(a: HashPool$2<any, Marker>, b: number[]): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: ScatterPolygonSeries);
    ap(): void;
    readonly c5: NumericMarkerManager;
    protected dk(a: IDictionary$2<any, OwnedPoint>): void;
    protected cz(): Point[];
    protected cy(): number[];
    private c1;
    private c0;
    private c6;
    private c4;
    protected cu(a: number, b: List$1<PointCollection>): PathGeometry;
    protected cc(a: FrameworkElement, b: any): void;
    protected ca(a: FrameworkElement, b: PathGeometry): void;
    private c8;
    c7: HashPool$2<any, Marker>;
    de(a: (arg1: Marker) => void): void;
    dg(a: HashPool$2<any, Marker>): void;
    c3(): Marker;
    protected c9: List$1<Marker>;
    di(a: Marker): void;
    dh(a: Marker): void;
    dj(a: Marker): void;
    dl(a: boolean): void;
    protected be(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a2(a: RenderingContext, b: boolean): void;
    dd(): void;
    db(): void;
    dc(): void;
    da(a: string): void;
    df(): void;
    private dm;
    dn(a: Marker): Size;
    c2(a: Point): Marker;
    ai(a: any): void;
    getDefaultTooltipTemplate(): string;
}
