/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, getInstanceType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
import { stringEndsWith } from "igniteui-angular-core";
/**
 * @hidden
 */
export class FinancialPriceSeriesProxy extends Base {
    getCloseMemberPath(a) {
        return a.oc;
    }
    getHighMemberPath(a) {
        return a.of;
    }
    getLowMemberPath(a) {
        return a.ok;
    }
    getOpenMemberPath(a) {
        return a.oo;
    }
    getVolumeMemberPath(a) {
        return a.os;
    }
    matchesType(a) {
        if (!a.cr) {
            return false;
        }
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator") || stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return false;
        }
        return true;
    }
    setCategoryMode(a, b) {
        a.mf = b;
    }
    setCloseMemberPath(a, b) {
        a.oc = b;
    }
    setDisplayType(a, b) {
        a.pk = b;
    }
    setHighMemberPath(a, b) {
        a.of = b;
    }
    setLowMemberPath(a, b) {
        a.ok = b;
    }
    setOpenMemberPath(a, b) {
        a.oo = b;
    }
    setVolumeMemberPath(a, b) {
        a.os = b;
    }
    setXAxis(a, b) {
        a.l8 = b;
    }
    setYAxis(a, b) {
        a.mt = b;
    }
}
FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
//# sourceMappingURL=FinancialPriceSeriesProxy.js.map