/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { RateOfChangeAndMomentumIndicatorStrategy } from "./RateOfChangeAndMomentumIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class RateOfChangeAndMomentumIndicator extends StrategyBasedIndicator {
    get_qc() {
        return new RateOfChangeAndMomentumIndicatorStrategy();
    }
    get qc() {
        return this.get_qc();
    }
    get_qp() {
        return RateOfChangeAndMomentumIndicator.$;
    }
    get qp() {
        return this.get_qp();
    }
    get qx() {
        return typeGetValue(this.c(RateOfChangeAndMomentumIndicator.qy));
    }
    set qx(a) {
        this.h(RateOfChangeAndMomentumIndicator.qy, a);
    }
    qi() {
        return this.qx;
    }
    qr(a) {
        this.qx = a;
    }
}
RateOfChangeAndMomentumIndicator.$t = markType(RateOfChangeAndMomentumIndicator, 'RateOfChangeAndMomentumIndicator', StrategyBasedIndicator.$);
RateOfChangeAndMomentumIndicator.qy = StrategyBasedIndicator.qu(14, RateOfChangeAndMomentumIndicator.$);
//# sourceMappingURL=RateOfChangeAndMomentumIndicator.js.map