import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    iu(a: SeriesView): void;
    protected m6: CrosshairLayerView;
    pa: Brush;
    pb: Brush;
    m7: Series;
    nc: boolean;
    na: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    m8(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    m9(): boolean;
    pe: Brush;
    pc: Brush;
    np: number;
    pd: Brush;
    readonly pi: Thickness;
    ng: number;
    ni: number;
    nh: number;
    nf: number;
    readonly pj: Thickness;
    nl: number;
    nn: number;
    nm: number;
    nk: number;
    nj: number;
    ph: Brush;
    pf: Brush;
    nq: number;
    pg: Brush;
    no: number;
    pl: Visibility;
    pk: Visibility;
    nb: boolean;
    protected ml(a: Series, b: boolean): void;
    protected mn(a: Frame, b: SeriesView): void;
    protected l8(a: Series): boolean;
    io(): void;
    private oi;
    private ne;
    private nd;
    protected oj(a: CrosshairLayerFrame, b: boolean): void;
    private oh;
    protected mq(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    protected iz(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b1: CrosshairLayer;
    b2: Pool$1<Path>;
    protected b3: List$1<Path>;
    ap(): void;
    private b9;
    private b4;
    private b6;
    private b5;
    b7(a: Path, b: number, c: number, d: number): void;
    b8(a: Brush): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
}
